source: master.sh@ d48846a

experimental
Last change on this file since d48846a was 40ccddf, checked in by Manuel Canales Esparcia <manuel@…>, 19 years ago

Separate current switches by books that can use it.

  • Property mode set to 100755
File size: 8.1 KB
Line 
1#!/bin/bash
2# $Id$
3set -e
4
5
6#>>>>>>>>>>>>>>>ERROR TRAPPING >>>>>>>>>>>>>>>>>>>>
7#-----------------------#
8simple_error() { # Basic error trap.... JUST DIE
9#-----------------------#
10 # If +e then disable text output
11 if [[ "$-" =~ "e" ]]; then
12 echo -e "\n${RED}ERROR:${GREEN} basic error trapped!${OFF}\n" >&2
13 fi
14}
15
16see_ya() {
17 echo -e "\n\t${BOLD}Goodbye and thank you for choosing ${L_arrow}JHALFS-X${R_arrow}\n"
18}
19##### Simple error TRAPS
20# ctrl-c SIGINT
21# ctrl-y
22# ctrl-z SIGTSTP
23# SIGHUP 1 HANGUP
24# SIGINT 2 INTRERRUPT FROM KEYBOARD Ctrl-C
25# SIGQUIT 3
26# SIGKILL 9 KILL
27# SIGTERM 15 TERMINATION
28# SIGSTOP 17,18,23 STOP THE PROCESS
29#####
30set -e
31trap see_ya 0
32trap simple_error ERR
33trap 'echo -e "\n\n${RED}INTERRUPT${OFF} trapped\n" && exit 2' 1 2 3 15 17 18 23
34#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
35
36
37if [ ! -L $0 ] ; then
38 echo "${nl_}${tab_}${BOLD}${RED}This script cannot be called directly: EXITING ${OFF}${nl_}"
39 exit 1
40fi
41
42 PROGNAME=$(basename $0)
43 COMMON_DIR="common"
44 PACKAGE_DIR=$(echo $PROGNAME | tr [a-z] [A-Z])
45 MODULE=$PACKAGE_DIR/master.sh
46MODULE_CONFIG=$PACKAGE_DIR/config
47
48echo -n "Loading common-functions module..."
49source $COMMON_DIR/common-functions
50[[ $? > 0 ]] && echo " $COMMON_DIR/common-functions did not load.." && exit
51echo "OK"
52#
53
54echo -n "Loading masterscript conf..."
55source $COMMON_DIR/config
56[[ $? > 0 ]] && echo "$COMMON_DIR/conf did not load.." && exit
57echo "OK"
58#
59echo -n "Loading config module <$MODULE_CONFIG>..."
60source $MODULE_CONFIG
61[[ $? > 0 ]] && echo "$MODULE_CONFIG did not load.." && exit 1
62echo "OK"
63#
64echo -n "Loading code module <$MODULE>..."
65source $MODULE
66[[ $? > 0 ]] && echo "$MODULE did not load.." && exit 2
67echo "OK"
68#
69echo "---------------${nl_}"
70
71
72#===========================================================
73# If the var BOOK contains something then, maybe, it points
74# to a working doc.. set WC=1, else 'null'
75#===========================================================
76WC=${BOOK:+1}
77#===========================================================
78
79
80#*******************************************************************#
81echo -n "Loading function <func_check_version.sh>..."
82source $COMMON_DIR/func_check_version.sh
83[[ $? > 0 ]] && echo " function module did not load.." && exit 2
84echo "OK"
85
86echo -n "Loading function <func_validate_configs.sh>..."
87source $COMMON_DIR/func_validate_configs.sh
88[[ $? > 0 ]] && echo " function module did not load.." && exit 2
89echo "OK"
90echo "---------------${nl_}"
91
92
93###################################
94### MAIN ###
95###################################
96
97# Evaluate any command line switches
98
99while test $# -gt 0 ; do
100 case $1 in
101 # Common options for all books
102 --book | -B )
103 test $# = 1 && eval "$exit_missing_arg"
104 shift
105 case $1 in
106 dev* | SVN | trunk )
107 LFSVRS=development
108 ;;
109 *) if [[ "$PROGNAME" = "lfs" ]]; then
110 case $1 in
111 6.1.1 )
112 echo "For stable 6.1.1 book, please use jhalfs-0.2."
113 exit 0
114 ;;
115 alpha*) LFSVRS=alphabetical ;;
116 udev*) LFSVRS=udev_update ;;
117 * ) echo "$1 is an unsupported version at this time." ;;
118 esac
119 else
120 echo "The requested version, ${L_arrow} ${BOLD}$1${OFF} ${R_arrow}, is undefined in the ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF} series."
121 exit 0
122 fi
123 ;;
124 esac
125 ;;
126
127 --directory | -D )
128 test $# = 1 && eval "$exit_missing_arg"
129 shift
130 BUILDDIR=$1
131 JHALFSDIR=$BUILDDIR/jhalfs
132 LOGDIR=$JHALFSDIR/logs
133 MKFILE=$JHALFSDIR/Makefile
134 ;;
135
136 --get-packages | -G ) HPKG=1 ;;
137
138 --help | -h )
139 if [[ "$PROGNAME" = "blfs" ]]; then
140 blfs_usage
141 else
142 usage
143 fi
144 ;;
145
146 --testsuites | -T )
147 test $# = 1 && eval "$exit_missing_arg"
148 shift
149 case $1 in
150 0 | 1 | 2 | 3 )
151 TEST=$1
152 ;;
153 * )
154 echo -e "\n$1 isn't a valid testsuites level value."
155 echo -e "You must to use 0, 1, 2, or 3.\n"
156 exit 1
157 ;;
158 esac
159 ;;
160
161 --version | -V )
162 clear
163 echo "$version"
164 exit 0
165 ;;
166
167 --working-copy | -W )
168 test $# = 1 && eval "$exit_missing_arg"
169 shift
170 case $PROGNAME in # Poor checks. We should find better ones.
171 lfs)
172 if [ -f $1/patches.ent ] ; then
173 WC=1
174 BOOK=$1
175 else
176 echo -e "\nLook like $1 isn't a LFS working copy."
177 exit 1
178 fi
179 ;;
180 clfs)
181 if [ -f $1/patches.ent ] && [ -f $1/packages.ent ]; then
182 WC=1
183 BOOK=$1
184 else
185 echo -e "\nLook like $1 isn't a CLFS working copy."
186 exit 1
187 fi
188 ;;
189 hlfs)
190 if [ -f $1/template.xml ] ; then
191 WC=1
192 BOOK=$1
193 else
194 echo -e "\nLook like $1 isn't a HLFS working copy."
195 exit 1
196 fi
197 ;;
198 blfs)
199 if [ -f $1/use-unzip.xml ] ; then
200 WC=1
201 BOOK=$1
202 else
203 echo -e "\nLook like $1 isn't a BLFS working copy."
204 exit 1
205 fi
206 ;;
207
208 # Common options for LFS, CLFS and HLFS
209 --fstab | -F )
210 test $# = 1 && eval "$exit_missing_arg"
211 shift
212 if [ -f $1 ] ; then
213 FSTAB=$1
214 else
215 echo -e "\nFile $1 not found. Verify your command line.\n"
216 exit 1
217 fi
218 ;;
219
220 --kernel-config | -K )
221 test $# = 1 && eval "$exit_missing_arg"
222 shift
223 if [ -f $1 ] ; then
224 CONFIG=$1
225 else
226 echo -e "\nFile $1 not found. Verify your command line.\n"
227 exit 1
228 fi
229 ;;
230
231 --make | -M ) RUNMAKE=1 ;;
232
233 --rebuild | -R ) CLEAN=1 ;;
234
235 * )
236 if [[ "$PROGNAME" = "blfs" ]]; then
237 blfs_usage
238 else
239 usage
240 fi
241 ;;
242 esac
243 shift
244done
245
246# Find the download client to use, if not already specified.
247
248if [ -z $DL ] ; then
249 if [ `type -p wget` ] ; then
250 DL=wget
251 elif [ `type -p curl` ] ; then
252 DL=curl
253 else
254 eval "$no_dl_client"
255 fi
256fi
257
258#===================================================
259# Set the document location...
260# BOOK is either defined in
261# xxx.config
262# comand line
263# default
264# If set by conf file or cmd line leave it
265# alone otherwise load the default version
266#===================================================
267BOOK=${BOOK:=$PROGNAME-$LFSVRS}
268#===================================================
269
270
271# Check for minumum gcc and kernel versions
272#check_requirements 1 # 0/1 0-do not display values.
273check_version "2.6.2" "`uname -r`" "KERNEL"
274check_version "3.0" "$BASH_VERSION" "BASH"
275check_version "3.0" "`gcc -dumpversion`" "GCC"
276tarVer=`tar --version`
277check_version "1.15.0" "${tarVer##* }" "TAR"
278echo "---------------${nl_}"
279
280validate_config 1 # 0/1 0-do not display values
281echo "---------------${nl_}"
282
283echo -n "Are you happy with that settings? yes/no (no): "
284read ANSWER
285if [ x$ANSWER != "xyes" ] ; then
286 echo "${nl_}Fix the configuration options and rerun the script.${nl_}"
287 exit 1
288fi
289
290# Prevents setting "-d /" by mistake.
291
292if [ $BUILDDIR = / ] ; then
293 echo -ne "\nThe root directory can't be used to build LFS.\n\n"
294 exit 1
295fi
296
297# If $BUILDDIR has subdirectories like tools/ or bin/, stop the run
298# and notify the user about that.
299
300if [ -d $BUILDDIR/tools -o -d $BUILDDIR/bin ] && [ -z $CLEAN ] ; then
301 eval "$no_empty_builddir"
302fi
303
304# If requested, clean the build directory
305clean_builddir
306
307if [[ ! -d $JHALFSDIR ]]; then
308 mkdir -pv $JHALFSDIR
309fi
310
311if [[ "$PWD" != "$JHALFSDIR" ]]; then
312 cp -v $COMMON_DIR/makefile-functions $JHALFSDIR/
313 if [[ -n "$FILES" ]]; then
314 # pushd/popd necessary to deal with mulitiple files
315 pushd $PACKAGE_DIR
316 cp -v $FILES $JHALFSDIR/
317 popd
318 fi
319 sed 's,FAKEDIR,'$BOOK',' $PACKAGE_DIR/$XSL > $JHALFSDIR/${XSL}
320 export XSL=$JHALFSDIR/${XSL}
321fi
322
323if [[ ! -d $LOGDIR ]]; then
324 mkdir -v $LOGDIR
325fi
326>$LOGDIR/$LOG
327echo "---------------${nl_}"
328
329get_book
330echo "---------------${nl_}"
331
332build_Makefile
333echo "---------------${nl_}"
334
335run_make
336
Note: See TracBrowser for help on using the repository browser.